
/*
 *                      A VALENTIEN'S DAY CARD FOR EVERYONE
 *
 *      WRITTEN BY :  MARCUS HOLT
 *    
 *      ASSIGNMENT # 5 FOR ENG142     SECTION :  BE
 *
 *      STUDENT # : 9734480
 * 
 *      FINISHED ON  FEB 26 1999
 *
 */

/* Please excuse the lack of order and good comments in this program.
 * I am a little pressed fo time because this took agout 15 more hours
 * than I thought it would.*/

/* My edit function is also woking erraticly at best
 * so I spent my time in a vain attempt to repair that
 * instead of making this program legible to others. */



#include "GP142.h"
#include <math.h>
#include <time.h>


#define MAIN_BUTTON_HT 30    /* All pound defines that are not self */
#define MAIN_BUTTON_WD 100   /* explanatory will be explained in the */
#define NUM_MAIN_BUTTONS 5   /* context of th program. */


#define SM_BUTTON_HT 30
#define SM_BUTTON_WD 30
#define NUM_COLORS 24

#define FILL 0
#define NOFILL 1

#define HEART  1
#define CLOVER 2
#define ARROW  3
#define STAR   4

#define LARGE 25
#define MEDIUM 15
#define SMALL 8

#define CLICK_BUTTON  1
#define CLICK_SCREEN  2
#define CLICK_OUTSIDE 3

#define MAIN_BUTTONS    1
#define COLOR_BUTTONS   2
#define SIZE_BUTTONS    3
#define MESSAGE_BUTTONS 4
#define SHAPE_BUTTONS   5
#define DELEAT          6

#define IGNORE 0
#define ON_CARD 1
#define ON_BUTTONS 2

#define ACTIVE 1
#define INACTIVE 0


void DrawBlankScreen (void);
void DrawCard ( int bkgroundColor, int open, int messageArray[][7],
		       int numMessages,  int shapeArray[][7], int numShapes);
void DrawButtons(int buttonType);

void CardClick(int x, int y, int *editNewMess, 
		  int *numMessages, int messageArray[][7],
		  int *buttonType, int shapeArray[][7],
		  int *numShapes, int *editNewShape,
		  int *changableS, int *changableM, int *edit,
		  int open);



void DrawHeart (int centerX, int centerY, int color, int size);
void DrawClover (int centerX, int centerY, int color, int size);
void DrawArrow (int centerX, int centerY, int color, int size);
void DrawStar (int centerX, int centerY, int color, int size);
void DrawShape (int color, int centerX, int centerY,
				                    int size, int shapeType);



void changes(int shapeArray[][7], int messageArray[][7],
	        	int numShapes, int numMessages, int x, int y, 
	        	int *changableS,int *changableM);



/* This group of functions is involved with interpreting
 * mouse clicks. There are several sets of on screen 
 * buttons so there are functions to represent the choices from
 * each interface,
 */
            /*  the initial button group */
void MainClick( int x, int y, int *buttonType, int *open,
		          int *back, int *edit);

            /* the buttons which show colors */
int  SelectColor   (int x, int y);

            /* the buttons that show the printable messages */
void SelectMessage (int x, int y, int messageArray[][7],
					int *numMessages,  int *editNewMess);

            /* the buttons that show shapes */
void SelectShape (int x, int y, int shapeArray[][7],
				  int *numShapes, int *editNewShape);

           /* the buttons that indicate the size choices */
int SelectSize (int x, int y);

          /* these buttons should allow the user to deleat 
		   * an object from the card, alas this was my last
		   * task and is not complete.  */ 

int SelectDeleat(int x, int y, int *buttonType);


/* While the above functions interperet mouse clicks the bellow
 * functions process the actual data that the mouse enters
 * so that it can be chanelled to the proper destinations 
 * to be usefull.  */


           /* serves more as an information conduit than a 
		    * practical function , passing info between
            * diffrent button functions  */
void ButtonClick( int x, int y, int *buttonType, int *color, 
			 int *open, int *back, int *bkgroundColor,
			 int *editNewMess, int messageArray[][7], int *numMessages,
			 int shapeArray[][7], int *numShapes, int *editNewShape,
			 int *size, int *edit, int * changableS,
			 int *changableM);

            /* deals with the coordinant location of tme mouse */  
int WhereClick (int x, int y, int open, int buttonType);

          /* another information conduit between a click on the 
		   * display field and the button controls */
void MouseClick (int x, int y, int *open, int *mouseLocate, 
			int *buttonType, int *color, int *back,
			int *bkgroundColor,  int *editNewMess,
			int messageArray[][7], int *numMessages, int shapeArray[][7],
			int *numShapes, int *editNewShape, int *size,
			int *edit ,int *changableS, int *changableM);




int main (void)
{
	int quit = 1;
	int event;
	int mouseX, mouseY;
	char keyHit;
	int open = 0;
	int bkgroundColor = 0;
	int buttonType = MAIN_BUTTONS;
	int mouseLocate;
	int color;
	int back = INACTIVE;
	int editNewMess = INACTIVE;
	int numMessages = 0;
	int numShapes = 0;
	int editNewShape = INACTIVE;
	int size = 15;
	int edit = INACTIVE;
	int changableS = -1;
	int changableM = -1;


	int messageArray[90][7];
	int shapeArray[90][7];

	GP142_open();
	GP142_show_text(0);
	GP142_logging(0);

	GP142_clear();
	GP142_animate(ANI_RUN);

	

	while (quit == 1)
	{
		
	DrawBlankScreen();

	DrawCard(bkgroundColor, open, messageArray, numMessages,
			 shapeArray, numShapes);

	DrawButtons (buttonType);

 
	
	event = GP142_await_event(&mouseX, &mouseY, &keyHit);


	switch (event){
	case GP142_QUIT:
		quit = 0;
		break;

	case GP142_KBD:
		break;

	case GP142_MOUSE:
		MouseClick(mouseX, mouseY, &open, &mouseLocate, &buttonType,
			&color, &back, &bkgroundColor,  &editNewMess,
			messageArray, &numMessages, shapeArray, &numShapes,
			&editNewShape, &size, &edit, &changableS, &changableM);
		

		break;

	case GP142_PERIODIC:
		break;

	default:
		break;
	}


	}
	GP142_close();

	return 0;
}

      /****************** functions *****************************/

void 
DrawBlankScreen (void) {
	int font_size = 14;

	GP142_rectangleXY (WHITE,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);
}

     /*****************************************/


void 
DrawHeart (int centerX, int centerY, int color, int size)
{
	GP142_circleXY (color, centerX - (int)((double)size / 1.5), centerY, size);
	GP142_circleXY (color, centerX + (int)((double)size / 1.5), centerY, size);
	GP142_triangleXY (color,
		              centerX - (int)(1.5 * (double)size),
					  centerY - (int)((double)size / 1.5),
					  centerX + (int)(1.5 * (double)size),
					  centerY - (int)((double)size / 1.5),
					  centerX,
					  centerY - (int)(2.5 * (double)size),
					  FILL);
}

     /*****************************************/

void 
DrawClover (int centerX, int centerY, int color, int size)
{


	DrawHeart (centerX, centerY + (int)( 1.2 * (double)size),
		       color, (int)(.5 * (double)size));

	GP142_triangleXY (color,
		             centerX, centerY,
					 (int)(centerX + (.25 * (double)size)), centerY - (2 * size),
				     (int)(centerX - (.25 * (double)size)), centerY - (2 * size),
					  FILL);

	GP142_circleXY (color, centerX + (int)(1.5 * (double)size ),
		centerY- (int)(.5 * (double)size / 1.5), (int)(.5 * (double)size));
	GP142_circleXY (color, centerX + (int)(1.5 * (double)size ),
		centerY+ (int)(.5 * (double)size / 1.5),(int)(.5 * (double)size));

	GP142_triangleXY (color,
		              centerX + (int)((double)size * 1.5),
					  centerY - (int)( 0.85 * (double)size),
					  centerX + (int)((double)size * 1.5),
					  centerY + (int)( 0.85 * (double)size),
					  centerX ,
					  centerY ,
					  FILL);

	GP142_circleXY (color, centerX - (int)(1.5 *(double)size ),
		centerY- (int)(.5 * (double)size / 1.5), (int)(.5 * (double)size));
	GP142_circleXY (color, centerX - (int)(1.5 * (double)size ),
		centerY+ (int)(.5 * (double)size / 1.5),(int)(.5 * (double)size));

	GP142_triangleXY (color,
		              centerX - (int)((double)size * 1.5),
					  centerY + (int)(.85 * (double)size),
					  centerX - (int)((double)size * 1.5),
					  centerY - (int)(.85 * (double)size),
					  centerX ,
					  centerY ,
					  FILL);
}

      /*****************************************/

void 
DrawArrow (int centerX, int centerY, int color, int size)
{
	int tipX = centerX + size;
	int tipY = centerY + size;
	int tailX = centerX - size;
	int tailY = centerY - size;
	GP142_lineXY(color, centerX - size, centerY - size,
				 centerX + size, centerY + size, (int)(size / 20));

	GP142_triangleXY (color,
						(int)(tipX + (double)size * 0.3),
						(int)(tipY + (double)size * 0.3),
						tipX,
						tipY,
						(int)(tipX - (double)size * 0.5),
						(int)(tipY + (double)size * 0.1),
						FILL);

	GP142_triangleXY (color,
						(int)(tipX + (double)size * 0.3),
						(int)(tipY + (double)size * 0.3),
						tipX,
						tipY,
						(int)(tipX + (double)size * 0.1),
						(int)(tipY - (double)size * 0.5),
						FILL);

	GP142_triangleXY (color,
						(int)(tailX + (double)size * 0.3),
						(int)(tailY + (double)size * 0.3),
						tailX,
						tailY,
						(int)(tailX - (double)size * 0.5),
						(int)(tailY + (double)size * 0.1),
						FILL);

	GP142_triangleXY (color,
						(int)(tailX + (double)size * 0.3),
						(int)(tailY + (double)size * 0.3),
						tailX,
						tailY,
						(int)(tailX + (double)size * 0.1),
						(int)(tailY - (double)size * 0.5),
						FILL);



}
        /**************************************/


void
DrawStar (int centerX, int centerY, int color, int size)
{
	GP142_triangleXY(color,
					(centerX - (2 * size)),
					 centerY,
					(centerX + (2 * size)),
					 centerY,
					 centerX,
					(int)(centerY - (2 * (double)size)),
					 FILL);

	GP142_triangleXY (color,
					  centerX,
					 (int)(centerY + ( (double)size)),
					 (centerX + (2 * size)),
					 (int)(centerY - ( (double)size)),
					 (centerX - (2 * size)),
                     (int)(centerY - ( (double)size)),
					  FILL);
}

        /*************************************/

void
DrawShape (int color, int centerX, int centerY,
				int size, int shapeType)
{
	switch (shapeType)
	{
	case HEART:
		DrawHeart(centerX, centerY, color, size);

		break;
	case CLOVER:
         DrawClover(centerX, centerY, color, size);

		break;
	case ARROW:
		 DrawArrow(centerX, centerY, color, size);
		
		break;
	case STAR:
		 DrawStar(centerX, centerY, color, size);

		break;
	}
}

        /*************************************/

void 
DrawCard ( int bkgroundColor, int open, int messageArray[][7],
		  int numMessages,  int shapeArray[][7], int numShapes)
{
	int pageLLX, i = -1, z = 0, text,
		color, x, y, size, type, path,
		page;


		char labels [5][55] =
		{		"Anonomusly \n adoring YOU",
				"You make me \n  Complete",
				"Our Love is \n  Eternal",
				"Helplessly hoping \nYou will keep \nLoving ME ",
				"Hell hath no fury",
		};


	if (open == 0)
		pageLLX = -GP142_XMAX + 300;
	if (open == 1)
		pageLLX = -GP142_XMAX + 100;


	GP142_rectangleXY
		( bkgroundColor,
		  pageLLX, -GP142_YMAX + 20,
		  GP142_XMAX - 20, GP142_YMAX - 20,
		  FILL);



	while (i <= numMessages)
	{
		color = messageArray[z][1];
		x     = messageArray[z][2];
		y     = messageArray[z][3];
		size  = messageArray[z][4];
		text  = messageArray[z][5];
		path  = messageArray[z][6];
		page  = messageArray[z][7];

		if (path == 3 && page == open)
		{
		
		GP142_printfXY(color, x, y, size, labels[text]);
		}
		i +=1; z +=1;
		
	}

	i = -1; z = 0;

	while (i <= numShapes)
	{
		color = shapeArray[z][1];
		x     = shapeArray[z][2];
		y     = shapeArray[z][3];
		size  = shapeArray[z][4];
		type  = shapeArray[z][5];
		path  = shapeArray[z][6];
		page  = shapeArray[z][7];
		


		if (path == 3 && page == open)
		{
		
		DrawShape(color, x, y, size, type);
		}
		i +=1; z +=1;
		
	}

}


void
changes(int shapeArray[][7], int messageArray[][7],
		int numShapes, int numMessages,
		int x, int y, int *changableS,
		int *changableM)
{
	int a = 0,  c = -1,
		d = 0,  f = -1;
		

	while (numShapes >= c)
	{
		if (x > (shapeArray[a][2] -10) && 
			x < (shapeArray[a][2] +10) &&
			y > (shapeArray[a][3] -10) &&
			y < (shapeArray[a][3] +10))
		{
			c = numShapes +1;
			*changableS = a;
		}
		else
		{	a+= 1;
			c += 1;
			*changableS = -1;  
		}
	}

	while (numMessages >= d)
	{
		if (x > (messageArray[f][2] -10) && 
			x < (messageArray[f][2] +10) &&
			y > (messageArray[f][3] -10) &&
			y < (messageArray[f][3] +10))
		{
			d = numMessages +1;
			*changableM = f;
		}
		else
		{	f +=1;
			d += 1;
			*changableM = -1; 
		}
	}
}


         /********************************/


void
DrawButtons(int buttonType)
{
	

	if(buttonType == MAIN_BUTTONS)
	{
	
		char labels [NUM_MAIN_BUTTONS][25] =
		{		"Background Color",
				"Shape",
				"Message",
				"Edit Object",
				"Open",
		};
	
		int i;
		for ( i = 0; i < NUM_MAIN_BUTTONS ; i++) 
		{
			int lowX = -GP142_XMAX; 
			int lowY = GP142_YMAX - ((i + 1) * MAIN_BUTTON_HT) - 20;
			int upX  = -GP142_XMAX + MAIN_BUTTON_WD;
			int upY  = GP142_YMAX - (i * MAIN_BUTTON_HT) - 20;

			GP142_rectangleXY (BLACK,
							 lowX, lowY,
							 upX, upY,
							 FILL);

			GP142_printfXY (RED, lowX + 10, lowY + 10, 10, labels[i]);
			GP142_lineXY (RED, upX, upY, upX, upY - 30, 2);
		}
	}   /* end main buttons */

	if (buttonType == COLOR_BUTTONS)
	{
		int i;
		for (i = 0; i < (NUM_COLORS / 2); i++)
		{

			int lowX = -GP142_XMAX; 
			int lowY = GP142_YMAX - ((i + 1) * SM_BUTTON_HT) - 20;
			int upX  = -GP142_XMAX + SM_BUTTON_WD;
			int upY  = GP142_YMAX - (i * SM_BUTTON_HT) - 20;
		
		    GP142_rectangleXY (i,
							   lowX, lowY,
							   upX, upY,
							   FILL);
		}   /* end colom one loop */

        for (i = 13; i <= (NUM_COLORS ); i++)
		{

			int lowX = -GP142_XMAX + SM_BUTTON_WD; 
			int lowY = GP142_YMAX - ((i - 12) * SM_BUTTON_HT) - 20;
			int upX  = -GP142_XMAX + (2 * SM_BUTTON_WD);
			int upY  = GP142_YMAX - ((i - 13) * SM_BUTTON_HT) - 20;
		
		    GP142_rectangleXY (i,
							   lowX, lowY,
							   upX, upY,
							   FILL);
		} /* end colom 2 loop */
		{
		char colorMessage[]={" click on your color of choice "};
		GP142_printfXY(RED, -280, -220, 12, colorMessage);
		}


	}     /* end color button  */

	if(buttonType == SIZE_BUTTONS)
	{
	
		char labels [3][15] =
		{		"LARGE",
				"Medium",
				"small",
		};
	
		int i;
		for ( i = 0; i < 3 ; i++) 
		{
			int lowX = -GP142_XMAX; 
			int lowY = GP142_YMAX - ((i + 1) * MAIN_BUTTON_HT) - 20;
			int upX  = -GP142_XMAX + MAIN_BUTTON_WD;
			int upY  = GP142_YMAX - (i * MAIN_BUTTON_HT) - 20;

			GP142_rectangleXY (BLACK,
							 lowX, lowY,
							 upX, upY,
							 FILL);

			GP142_printfXY (RED, lowX + (4*i) , lowY + (4*i) ,
				            30 / (i + 1), labels[i]);
			GP142_lineXY (RED, upX, upY, upX, upY - 30, 2);
		}
		{
		char sizeMessage[]={"WOW, these all come in sizes"};
		GP142_printfXY(RED,-280, -220, 12, sizeMessage);
		}



	}     /* end size buttons */


	if(buttonType == MESSAGE_BUTTONS)
	{
	
		char labels [5][55] =
		{		"Anonomusly \n adoring YOU",
				"You make me \n  Complete",
				"Our Love is \n  Eternal",
				"Helplessly hoping \nYou will keep \nLoving ME ",
				"Hell hath no fury",
		};
	
		int i;
		for ( i = 0; i < 5 ; i++) 
		{
			int lowX = -GP142_XMAX; 
			int lowY = GP142_YMAX - ((i + 1) * (MAIN_BUTTON_HT + 20)) - 20;
			int upX  = -GP142_XMAX + MAIN_BUTTON_WD;
			int upY  = GP142_YMAX - (i * (MAIN_BUTTON_HT + 20)) - 20;

			GP142_rectangleXY (BLACK,
							 lowX, lowY,
							 upX, upY,
							 FILL);

			GP142_printfXY (RED, lowX + 15, lowY + 30, 10, labels[i]);
			GP142_lineXY (RED, upX, upY, upX, upY - 50, 2);
		}
		{
		char messageMessage[]={"click on the message that best suits you"};
		GP142_printfXY(RED, -280, -220,12, messageMessage);
		}
	}   /* end message buttons */


	if (buttonType == SHAPE_BUTTONS)
	{
		int i;
		for (i = 0; i < 4; i++)
		{

			int lowX = -GP142_XMAX; 
			int lowY = GP142_YMAX - ((i + 1) * (SM_BUTTON_HT * 2)) - 20;
			int upX  = -GP142_XMAX + (SM_BUTTON_WD * 2);
			int upY  = GP142_YMAX - (i * (SM_BUTTON_HT * 2)) - 20;
		
		    GP142_rectangleXY (BLACK,
							   lowX, lowY,
							   upX, upY,
							   FILL);
			DrawShape( RED, (lowX +upX) /2, (lowY + upY) /2, 10, i + 1);
		}
		{
			char shapeMessage[]={"four shapes for your viewing pleasure"};
			GP142_printfXY(RED,-280, -220, 12, shapeMessage);
		}

	}

	if (buttonType == INACTIVE)
	{
		char inactiveMessage1[] = {"Please select a location on the screen"};
		char inactiveMessage2[] = {"to place an object or message."};
		char inactiveMessage3[] = {"or select an object to be edited"};
		GP142_printfXY( RED, -280, -100, 12, inactiveMessage1);
		GP142_printfXY( RED, -280, -120, 12, inactiveMessage2);
		GP142_printfXY( RED, -280, -140, 12, inactiveMessage3);
	}

	if (buttonType == DELEAT)
	{
		char labels [2][25] =
		{		"DELEAT, PLEASE",
				"DON'T DELEAT",
		};

	int i;
		for ( i = 0; i < 2 ; i++) 
		{
			int lowX = -GP142_XMAX; 
			int lowY = GP142_YMAX - ((i + 1) * MAIN_BUTTON_HT) - 20;
			int upX  = -GP142_XMAX + MAIN_BUTTON_WD;
			int upY  = GP142_YMAX - (i * MAIN_BUTTON_HT) - 20;

			GP142_rectangleXY (BLACK,
							 lowX, lowY,
							 upX, upY,
							 FILL);

			GP142_printfXY (RED, lowX + 10, lowY + 10, 10, labels[i]);
			GP142_lineXY (RED, upX, upY, upX, upY - 30, 2);
		}
	}

}
         /*******************************************/

int
SelectColor(int x, int y)
{
	int color = 5;

	
	

		if (   x > (-GP142_XMAX + 30) 
			&& x < (-GP142_XMAX + 60)
            && y < ( GP142_YMAX - 20) 
            && y > ( GP142_YMAX - 360))

		 color = 13 + (int)((GP142_YMAX - 20 - y) / 30);

		else if (   x > (-GP142_XMAX     ) 
			&& x < (-GP142_XMAX + 30)
            && y < ( GP142_YMAX - 20) 
            && y > ( GP142_YMAX - 360))

		 color =  (int)((GP142_YMAX - 20 - y) / 30);
		
		else
			color = -1;



	return(color);
}

        /****************************************************/


void
MainClick( int x, int y, int *buttonType, int *open,
		  int *back, int *edit)
{
	
	if ( y > GP142_YMAX - 50)
	{
		*buttonType = COLOR_BUTTONS;
		*back = ACTIVE;
	}
	
	else if ( y > GP142_YMAX - 80)
	{
		*buttonType = SHAPE_BUTTONS;
		
	}
		

	else if ( y > GP142_YMAX - 120)
	{
		*buttonType = MESSAGE_BUTTONS;
	}	

	else if ( y > GP142_YMAX - 150)
	{
		*edit = ACTIVE;
		*buttonType = INACTIVE;
	}
	
	else if ( y > GP142_YMAX - 180)
	{
		if (*open == 1)
			*open = 0;
		else
			*open = 1;
	}
	
		
	
}

       /*****************************************************/


void
SelectMessage (int x, int y,
			   int messageArray[][7], int *numMessages,
			   int *editNewMess)
{

	
		if  ( x >  -GP142_XMAX
		   && x < (-GP142_XMAX + 100)
           && y < ( GP142_YMAX - 20) 
           && y > ( GP142_YMAX - 270))
		{
		   messageArray[*numMessages] [5] = 
		          (int)((GP142_YMAX - 20 - y)/50);
		   messageArray[*numMessages][6] = 1;

		*editNewMess = ACTIVE;
		
		}
}

          /***************************************************/


void
SelectShape (int x, int y,
			 int shapeArray[][7], int *numShapes,
			 int *editNewShape)
{
	int temp = 0;

	if (   x >  -GP142_XMAX
		&& x < (-GP142_XMAX + 60)
        && y < ( GP142_YMAX - 20) 
        && y > ( GP142_YMAX - 260))
	
		temp = 1 + (int) ((GP142_YMAX - 20 - y) / 60);

		if(temp > 0 && temp < 5)
		{
			shapeArray[*numShapes][5] = temp;
            *editNewShape = ACTIVE;
			shapeArray[*numShapes][6] = 1;
		}
		else
			*editNewShape =INACTIVE;
	
}


           /*************************************************/


int
SelectSize (int x, int y)
{
	int temp, size ;
		if ( x >  -GP142_XMAX
		  && x < (-GP142_XMAX + 100)
          && y < ( GP142_YMAX - 20) 
          && y > ( GP142_YMAX - 110))
		
			temp =  1 + ( (GP142_YMAX - 20 - y) / 30);
			if (temp == 1)
				size = LARGE;
			if (temp == 2)
				size = MEDIUM;
			if (temp == 3)
				size = SMALL;
		

	return(size);
}

        /*********************************************************/

void
CardClick(int x, int y, int *editNewMess, 
		  int *numMessages, int messageArray[][7],
		  int *buttonType, int shapeArray[][7],
		  int *numShapes, int *editNewShape,
		  int *changableS, int *changableM, int *edit,
		  int open)
{
	if (*editNewMess == ACTIVE)
	{	
		messageArray[*numMessages][7] = open;
		messageArray[*numMessages][2] = x;
		messageArray[*numMessages][3] = y;
		*buttonType = MAIN_BUTTONS;
		*editNewMess = INACTIVE;
		*numMessages +=1;

	}

	if (*editNewShape == ACTIVE)
	{	
		shapeArray[*numShapes][7] = open;
		shapeArray[*numShapes][2] = x;
		shapeArray[*numShapes][3] = y;
		*buttonType = MAIN_BUTTONS;
		*editNewShape = INACTIVE;
		*numShapes +=1;

	}

	if (*edit == ACTIVE)
	{
		changes(shapeArray, messageArray,
		*numShapes, *numMessages, x, y,
		changableS, changableM);

		if (*changableS >= 0 || *changableM >=0)
		{
			*buttonType = COLOR_BUTTONS;
		}
	}
}
		
       /**********************************************/


void
ButtonClick( int x, int y, int *buttonType, int *color, 
			 int *open, int *back, int *bkgroundColor,
			 int *editNewMess, int messageArray[][7], int *numMessages,
			 int shapeArray[][7], int *numShapes, int *editNewShape,
			 int *size, int *edit, int * changableS,
			 int *changableM)
{

		int temp = 0;

	switch ( *buttonType)
	{
	case MAIN_BUTTONS:
		MainClick(x, y, buttonType, open, back, edit );


		break;

	case COLOR_BUTTONS:

		if (*back == ACTIVE)
		{
			*bkgroundColor = SelectColor( x, y );
			*back = INACTIVE;
			*buttonType = MAIN_BUTTONS;
		}

		if (*editNewMess == ACTIVE)
		{
			*color = SelectColor(x, y);
			messageArray[*numMessages][1] = *color;
			messageArray[*numMessages][6] = 2;
			*buttonType = SIZE_BUTTONS;
		}

		if (*editNewShape == ACTIVE)
		{
			*color = SelectColor(x, y);
			shapeArray[*numShapes][1] = *color;
			shapeArray[*numShapes][6] = 2;
			*buttonType = SIZE_BUTTONS;
		}

		if (*edit == ACTIVE &&  *changableS >=0)
		{
			*color = SelectColor(x,y);
			shapeArray[*changableS][1] = *color;
			*buttonType = SIZE_BUTTONS;
		}

		if ((*edit == ACTIVE) && (*changableM >=0))
		{
			*color = SelectColor(x,y);
			messageArray[*changableM][1] = *color;
			*buttonType = SIZE_BUTTONS;
		}


		break;

	case SIZE_BUTTONS:

		if (*editNewMess == ACTIVE)
		{
			*size = SelectSize(x, y);
			messageArray[*numMessages][4] = *size;
			messageArray[*numMessages][6] = 3;
			*buttonType = INACTIVE;
			
		}

		if (*editNewShape == ACTIVE)
		{
			*size = SelectSize(x, y);
			shapeArray[*numShapes][4] = *size;
			shapeArray[*numShapes][6] = 3;
			*buttonType = INACTIVE;
		}

		if (*edit == ACTIVE &&  *changableS >=0)
		{
			*size = SelectSize (x, y);
			shapeArray[*changableS][4] = *size;
			*buttonType = DELEAT;
		}

		if ((*edit == ACTIVE) && (*changableM >=0))
		{
			*size = SelectSize (x,y);
			messageArray[*changableM][4] = *size;
			*buttonType = DELEAT;
		}

		break;

	case MESSAGE_BUTTONS:


		SelectMessage(x, y, messageArray, numMessages,
						editNewMess);
		*buttonType = COLOR_BUTTONS;
		
		break;

	case SHAPE_BUTTONS:
		SelectShape(x, y, shapeArray, numShapes,
					editNewShape);
		*buttonType = COLOR_BUTTONS;

		break;

	case DELEAT:

		if ( x< -GP142_XMAX +100 &&
		 x> -GP142_XMAX  &&
		 y> GP142_YMAX - 50 &&
		 y< GP142_YMAX - 20)

		{ shapeArray[*changableS][5] = 0;


		*buttonType = MAIN_BUTTONS;}
		else
			*buttonType = MAIN_BUTTONS;
		
		break;

	}
}

         /**************************************************/



int
WhereClick (int x, int y, int open, int buttonType)
{
	int mouseLocate;

	if ((open == 0)
		&& (x > (-GP142_XMAX + 300)) 
		&& (x < ( GP142_XMAX - 20)) 
		&& (y > (-GP142_YMAX + 20))
		&& (y < ( GP142_YMAX - 20)))

		mouseLocate = ON_CARD;

	if (open == 1
		&& x > (-GP142_XMAX + 100) 
		&& x < ( GP142_XMAX - 20) 
		&& y > (-GP142_YMAX + 20)
		&& y < ( GP142_YMAX - 20))

		mouseLocate = ON_CARD;

	if ( buttonType == MAIN_BUTTONS
		&& x >  -GP142_XMAX
		&& x < (-GP142_XMAX + 100)
        && y < ( GP142_YMAX - 20) 
        && y > ( GP142_YMAX - 170))

		mouseLocate = ON_BUTTONS;

	if ( buttonType == COLOR_BUTTONS
		&& x >  -GP142_XMAX
		&& x < (-GP142_XMAX + 60)
        && y < ( GP142_YMAX - 20) 
        && y > ( GP142_YMAX - 380))

		mouseLocate = ON_BUTTONS;

	if ( buttonType == SIZE_BUTTONS
		&& x >  -GP142_XMAX
		&& x < (-GP142_XMAX + 100)
        && y < ( GP142_YMAX - 20) 
        && y > ( GP142_YMAX - 110))
		
		mouseLocate = ON_BUTTONS;

	if ( buttonType == MESSAGE_BUTTONS
		&& x >  -GP142_XMAX
		&& x < (-GP142_XMAX + 100)
        && y < ( GP142_YMAX - 20) 
        && y > ( GP142_YMAX - 270))

		mouseLocate = ON_BUTTONS;

	if ( buttonType == SHAPE_BUTTONS
		&& x >  -GP142_XMAX
		&& x < (-GP142_XMAX + 60)
        && y < ( GP142_YMAX - 20) 
        && y > ( GP142_YMAX - 260))

		mouseLocate = ON_BUTTONS;

	if 	( buttonType == DELEAT &&
		 x< -GP142_XMAX +100 &&
		 x> -GP142_XMAX  &&
		 y> GP142_YMAX - 80 &&
		 y< GP142_YMAX - 20)

		 mouseLocate = ON_BUTTONS;

	if (mouseLocate != ON_BUTTONS &&
		mouseLocate != ON_CARD)

		mouseLocate = IGNORE;

	return (mouseLocate);
}

            /*****************************************************/

void
MouseClick (int x, int y, int *open, int *mouseLocate, 
			int *buttonType, int *color, int *back,
			int *bkgroundColor,  int *editNewMess,
			int messageArray[][7], int *numMessages, int shapeArray[][7],
			int *numShapes, int *editNewShape, int *size,
			int *edit ,int *changableS, int *changableM)
{



	*mouseLocate = WhereClick(x, y, *open, *buttonType);
	

	if (*mouseLocate == ON_BUTTONS)
		ButtonClick ( x, y, buttonType, color, 
		open, back, bkgroundColor,
		editNewMess, messageArray, numMessages,
		shapeArray, numShapes, editNewShape,
		size, edit, changableS, changableM);

	if (*mouseLocate == ON_CARD)
		CardClick(x, y, editNewMess, 
		  numMessages,  messageArray,
		  buttonType, shapeArray,
		  numShapes, editNewShape,
		  changableS, changableM , 
		  edit, *open);
}



/******************* end functions **********************/

